src/widgets/qlabel.cpp    2.21  agulbra  +9 -5

  new sizeHint(); "yes\nyes" is as tall as "Yes\nYes"


src/tools/qstrlist.h    2.7  hanord  +10 -9  (1997/10/16)

  Fixed STL crash reported by ust@egd.igd.fhg.de


src/kernel/qregion.cpp    2.5  agulbra  +3 -3  (1997/10/19)
src/kernel/qregion.h    2.6  agulbra  +2 -2

  USL C++ understands xor


src/kernel/qkeycode.h    2.5  hanord  +13 -2  (1997/10/22)

  Added function keys F25..F35 for X only


src/widgets/qpushbt.cpp    2.33  hanord  +5 -9

  Always clear button background in Windows style


src/widgets/qpushbt.cpp    2.32  hanord  +8 -8

  Fixed background color for windows style


src/kernel/qcur_win.cpp    2.5  hanord  +15 -5

  Fix the cursor bug on Win95


src/kernel/qobject.cpp    2.36  eiriken  +3 -3
src/kernel/qwid_win.cpp    2.39  eiriken  +19 -17

  Fixed bugs in setMaximumSize and setMinimumSize


src/widgets/qlabel.cpp    2.23  agulbra  +11 -2
src/widgets/qlabel.h    2.5  agulbra  +2 -1

  add clear()


src/kernel/qapp.cpp    2.38  eiriken  +8 -2  (1997/10/31)

  Added warning in QApplication::palette() if called before a QApplication
  is created.


src/kernel/qcolor.h    2.8  hanord  +6 -7

  Fixed the color== operator


src/kernel/qcol_win.cpp    2.16  hanord  +13 -41
src/kernel/qcolor.cpp    2.12  hanord  +118 -36
src/kernel/qcolor.h    2.7  hanord  +7 -6

  Moved platform independent functions into qcolor.cpp
  Optimized setNamedColor for #RRGGBB style color names.
  Doc warns that RGB bit format may change in the future.
  setRgb(QRgb) optimized.
  Added static class member color_init (not a global file variable)


src/kernel/qapp_win.cpp    2.64  hanord  +67 -50

  Detects the Windows version using GetVersionEx.
  Moved the timer function to the appropriate section.


src/kernel/qclb_x11.cpp    2.4  agulbra  +6 -5

  call XInternAtoms() once instead of XInternAtom N times.  should
  improve start-up time by about 3-5 times the ping time to the server.


src/widgets/qlistbox.h    2.12  agulbra  +2 -1  (1997/11/09)

  don't let down-arrow set the current item to be half-visible


src/kernel/qpainter.cpp    2.17  hanord  +61 -5  (1997/11/12)
src/kernel/qpainter.h    2.12  hanord  +2 -1

  Added new begin() which takes a paint device and a widget to copy pen, font
  etc. from.
  Fixed inverted dense pattern on Windows.


src/widgets/qslider.cpp    2.45  paul  +3 -2

  fixing bug when setting value in constructor followed by resetting value
  to zero.


src/kernel/qimage.cpp    2.65.2.1  agulbra  +4 -4

  avoid segfaults for image handlers where either read or
  write is 0.  enables gif image handlers.


src/qt.pro    2.6  agulbra  +4 -2  (1997/11/20)
src/kernel/qdragobject.cpp    2.1  agulbra  initial checkin
src/kernel/qdragobject.h    2.1  agulbra  initial checkin
src/kernel/qevent.h    2.6  agulbra  +59 -2
src/widgets/qlined.cpp    2.54  agulbra  +92 -3
src/widgets/qlined.h    2.19  agulbra  +3 -1

  QDragObject and related goodies.  not ready for prime time, but hey!


src/widgets/qcombo.cpp    2.68  agulbra  +52 -2
src/widgets/qcombo.h    2.20  agulbra  +5 -1

  new function setListBox() - allows custom combos like the ones in ACT


src/kernel/qapp_win.cpp    2.65  warwick  +4 -3
src/kernel/qwid_win.cpp    2.43  warwick  +51 -19

  Reimplement QWidget::recreate(), using almost same code as X11 version.


src/kernel/qptr_win.cpp    2.21.2.1  hanord  +8 -8  (1997/11/25)

  Fixed bad dense patterns


src/widgets/qchkbox.cpp    2.17  warwick  +16 -7  (1997/11/28)
src/widgets/qradiobt.cpp    2.21  warwick  +18 -7

  Check pixmap in sizeHint()


src/kernel/qpainter.h    2.14  hanord  +3 -1  (1997/12/02)

  Added xForm and xFormDev with index,npoints arguments


src/kernel/qpainter.cpp    2.19  hanord  +399 -2
src/kernel/qptr_x11.cpp    2.31  hanord  +45 -333

  Moved platform-independent xForm functions into qpainter.cpp.
  Fixed bugs in drawPoints, drawPolyline, drawLineSegments and
  drawPolygon where index > 0 or npoints < array size.
  Added xForm(pointarray,index,size) and similar xFormDev().
  Now Purify should shut up.
  Removed some tests for cpen.style() != NoPen.  Makes some code
  somewhat slower, but makes QPainter more consistent.


src/kernel/qptd_x11.cpp    2.9  hanord  +11 -3
src/kernel/qptr_x11.cpp    2.30  hanord  +11 -5

  Set graphics exposures to FALSE except when bitBlt from widget to widget


src/kernel/qpm_win.cpp    2.29  hanord  +12 -12

  When converting an image to a pixmap, don't create a new pixmap unless
  the depth or dimension changes.


src/widgets/qlined.cpp    2.56  agulbra  +64 -41
src/widgets/qlined.h    2.21  agulbra  +6 -3

  various small fixes, mostly to draw correctly.  added setFont() and
  setEnabled() to update correctly, I guess we need setStyle() and
  setPalette() too.


src/dialogs/qmsgbox.cpp    2.40  warwick  +8 -6  (1997/12/08)

  Correct layout for text smaller than icon.


src/widgets/qprogbar.cpp    2.15  warwick  +22 -8

  Ensure display is up-to-date when a progress bar is re-used.


src/kernel/qptr_x11.cpp    2.32  warwick  +4 -2

  Fix out-of-bounds clipping.


src/kernel/qapp_win.cpp    2.67  hanord  +23 -8

  Get the app name even for console applications (when WinMain isn't called)


src/kernel/qasyncimageio.cpp    1.23  warwick  +57 -26
src/kernel/qasyncimageio.h    1.12  warwick  +2 -1

  Handle nasty GIFs.


src/widgets/qspinbox.cpp    2.24  aavit  +170 -25  (1997/12/09)
src/widgets/qspinbox.h    2.14  aavit  +17 -8

  Improved QSpinbox - now easier to subclass; and "Auto" choice added.


src/tools/qregexp.cpp    2.6  hanord  +15 -12

  Fixed serious bug: regular expression with characters > 127 now works.


src/kernel/qprn_x11.cpp    2.6  warwick  +3 -3

  QPrinter::newPage() previous always returned FALSE.  Fixed.


src/widgets/qscrbar.cpp    2.30  agulbra  +6 -6

  be a bit kinder and gentler about the hot zone in windows style.  the
  old limit (30 pixels to either side of the bar) was too tight


src/kernel/qapp_win.cpp    2.68  hanord  +6 -3  (1997/12/15)

  Fixed the modal loop problem related to synch popups with signals


src/widgets/qlined.cpp    2.57  agulbra  +8 -8  (1998/01/05)

  don't allow paste from ****'ed line edits


src/kernel/qasyncimageio.cpp    1.25  warwick  +14 -6  (1998/01/06)

  Be more forgiving about broken GIF - as forgiving as netscape


src/kernel/qasyncimageio.cpp    1.24  warwick  +5 -2

  Protection against more broken GIFs.


extensions/xt/doc.conf    1.1  warwick  initial checkin  (1998/01/07)
extensions/xt/doc/annotated.doc    1.1  warwick  initial checkin
extensions/xt/doc/classes.doc    1.1  warwick  initial checkin
extensions/xt/doc/examples.doc    1.1  warwick  initial checkin
extensions/xt/doc/index.doc    1.1  warwick  initial checkin
extensions/xt/examples/mainlyMotif/editor.cpp    1.1  warwick  initial checkin
extensions/xt/examples/mainlyMotif/editor.pro    1.1  warwick  initial checkin
extensions/xt/examples/mainlyQt/editor.cpp    1.1  warwick  initial checkin
extensions/xt/examples/mainlyQt/editor.pro    1.1  warwick  initial checkin
extensions/xt/examples/mainlyXt/editor.cpp    1.1  warwick  initial checkin
extensions/xt/examples/mainlyXt/editor.pro    1.1  warwick  initial checkin
extensions/xt/src/qxt.cpp    1.1  warwick  initial checkin
extensions/xt/src/qxt.h    1.1  warwick  initial checkin
extensions/xt/src/qxt.pro    1.1  warwick  initial checkin

  Qt Xt/Motif Extension, examples, docs.


src/kernel/qevent.cpp    2.7  paul  +48 -9  (1998/01/08)
src/kernel/qevent.h    2.9  paul  +17 -1
src/kernel/qgmanagr.cpp    2.22  paul  +97 -10
src/kernel/qgmanagr.h    2.7  paul  +3 -1
src/kernel/qlayout.cpp    2.27  paul  +2 -23
src/kernel/qwid_win.cpp    2.44  paul  +19 -3
src/kernel/qwidget.cpp    2.85  paul  +10 -2

  New events ChildInserted, ChildRemoved and LayoutHint. Not tested on Windows.
  Use new events in GM.


src/qt.pro    2.11  paul  +2 -0
src/widgets/qsplitter.cpp    1.1  paul  initial checkin
src/widgets/qsplitter.h    1.1  paul  initial checkin

  New widget QSplitter


src/kernel/qpntarry.cpp    2.12  warwick  +4 -4

  Fix quad bezier for small curves


src/kernel/qwidget.cpp    2.87  agulbra  +71 -16
src/kernel/qwidget.h    2.38  agulbra  +5 -2
src/kernel/qwindefs.h    2.20  agulbra  +2 -1

  added setAutoMinimumSize().  fixed a couple of documentation errors.


src/kernel/qwid_win.cpp    2.45  warwick  +4 -3  (1998/01/13)

  Fix case of recreate(0,...) on tlw.


src/widgets/qbutton.cpp    2.40.2.1  agulbra  +7 -7

  paint correctly when there is a background color


src/widgets/qlined.cpp    2.58  paul  +18 -8  (1998/01/14)

  Correct cursor when end(). Better blinking


src/dialogs/qtabdlg.cpp    2.36  agulbra  +172 -213
src/dialogs/qtabdlg.h    2.17  agulbra  +2 -1
src/kernel/qgmanagr.cpp    2.23  agulbra  +22 -21
src/widgets/qtabbar.cpp    2.30  agulbra  +12 -15
src/widgets/qwidgetstack.cpp    2.1  agulbra  initial checkin
src/widgets/qwidgetstack.h    2.1  agulbra  initial checkin

  The new class QWidgetStack encapsulates a bunch of widgets of the same
  size, where the one on top of the stack is visible.  It provides slots
  to raise any of the widgets to the top of the stack and so on.
  
  QTabDialog now uses QWidgetStack.  A couple of hacks went away, and it
  now uses QBoxLayout to manage its children.  Some more minor changes
  are desirable here.
  
  QTabBar now uses autoMinimumSize() appropriately, and is closer to the
  new Windows look and feel (ie. it lost the bold stuff).  QTabDialog is
  adapted accordingly.
  
  QGManager now has a one-line VERY INEFFICENT fix that SORELY NEEDS
  OPTIMIZATION to make layout hint events propagate outwards correctly.
  There's about twenty hashes on the relevant line.  This change is the
  whole point of the check-in: Most things that use QWidgetStack will
  really need this fix.  Paul, optimize it, please?


src/kernel/qobject.cpp    2.42  agulbra  +13 -2

  show geometry and visibility too in dumpObjectTree()


src/qt.pro    2.12  agulbra  +10 -0
src/widgets/qmainwindow.cpp    2.1  agulbra  initial checkin
src/widgets/qmainwindow.h    2.1  agulbra  initial checkin
src/widgets/qstatusbar.cpp    2.1  agulbra  initial checkin
src/widgets/qstatusbar.h    2.1  agulbra  initial checkin
src/widgets/qtoolbar.cpp    2.1  agulbra  initial checkin
src/widgets/qtoolbar.h    2.1  agulbra  initial checkin
src/widgets/qtoolbutton.cpp    2.1  agulbra  initial checkin
src/widgets/qtoolbutton.h    2.1  agulbra  initial checkin

  several new classes.  very rough and ready, but they're good enough to
  talk about and play with.


src/widgets/qframe.cpp    2.11  paul  +33 -5
src/widgets/qframe.h    2.4  paul  +8 -2

  New function setMargin()


examples/showimg/showimg.cpp    2.18  warwick  +25 -6  (1998/01/21)
examples/showimg/showimg.h    2.6  warwick  +3 -1
src/kernel/qimage.h    2.22  warwick  +5 -1

  QImage::smoothScale(int with, int height)


src/widgets/qpopmenu.h    2.10  agulbra  +3 -2

  new signal aboutToShow(), like the one in QTabDialog.


src/tools/qstring.cpp    2.16  warwick  +44 -3  (1998/01/23)

  Make QString implicitly shared.  Activates in Qt 2.00.
  Try enabling this protection next time you have some weird bug.


src/kernel/qclb_x11.cpp    2.6  hanord  +155 -46

  INCR paste works.


src/qt.pro    2.13  agulbra  +2 -0
src/widgets/qwhatsthis.cpp    2.1  agulbra  initial checkin
src/widgets/qwhatsthis.h    2.1  agulbra  initial checkin

  what's this?  
  it's not perfect, but it definitely is nice.


extensions/imageio/src/qpngio.cpp    1.6  warwick  +9 -4  (1998/01/27)

  Don't set alpha if not necessary.


src/kernel/qpm_win.cpp    2.31  hanord  +5 -11

  Preserves mask when converting an image to a pixmap


src/kernel/qapp.cpp    2.42  agulbra  +7 -7

  corrected dark shadow colour - has been too dark since warwick fixed
  QColor::dark().


src/kernel/qprn_win.cpp    2.6  hanord  +11 -5

  Printing now works on DeskJet 890c (StretchDIBits didn't work)
  We now do StretchBlt.


src/widgets/qpopmenu.h    2.12  warwick  +2 -1  (1998/02/06)

  Allow position in QPopupMenu::exec(...)


src/kernel/qpntarry.cpp    2.13  warwick  +14 -15

  QPointArray::makeArc() now works with negative "alen" angle.
   - QPainter::drawArc() uses this for arcs under transformation.


src/widgets/qbttngrp.cpp    2.8  aavit  +34 -10
src/widgets/qbttngrp.h    2.3  aavit  +2 -1

  bugfix: Untoggling of other buttons in an exclusive group
  if a button was set with setChecked() did not work.


src/widgets/qslider.cpp    2.47  agulbra  +15 -28

  made valueChanged() work correctly with middle-button dragging when
  !tracking().  simplified the mouse state machine a little.


src/tools/qdir.cpp    2.16  hanord  +4 -8  (1998/02/11)
src/tools/qfile.cpp    2.13  hanord  +36 -2
src/tools/qfile.h    2.3  hanord  +4 -1

  Added QFile::remove() which removes a file


src/widgets/qlined.cpp    2.60  agulbra  +12 -2  (1998/02/19)
src/widgets/qlined.h    2.23  agulbra  +5 -3

  add clear(), make setText() and insert() public


src/widgets/qlistview.cpp    2.52  agulbra  +33 -2
src/widgets/qlistview.h    2.25  agulbra  +3 -1

  added a sizeHint()


src/tools/qdir.cpp    2.17  agulbra  +4 -4
src/tools/qfileinf.cpp    2.7  agulbra  +5 -4

  do what the docs say for absFilePath() (ie. no /usr/../usr/bin/ls names)


src/widgets/qtablevw.cpp    2.41  agulbra  +31 -23

  scrollLast*Cell and clipToCell could not be combined.  now they can.


src/widgets/qframe.cpp    2.13  warwick  +4 -4  (1998/02/20)

  Fix Box and H/VLine frames with margin() != 0.


src/qt.pro    2.15  warwick  +2 -0
src/widgets/qlabelled.cpp    1.1  warwick  initial checkin
src/widgets/qlabelled.h    1.1  warwick  initial checkin

  QLabelled widget (experimental)


src/kernel/qapp.cpp    2.45  agulbra  +28 -13
src/kernel/qapp_win.cpp    2.73  agulbra  +14 -13

  deliver mouse events to application-wide event filters even if the
  receiver object is disabled.  this allows tooltips to work for
  disabled widgets.


src/widgets/qcombo.h    2.23  agulbra  +3 -2

  make eventFilter() public.  this may break binary compatibility on
  msvc++, if anyone's built a dll yet.


src/widgets/qradiobt.cpp    2.23  agulbra  +7 -17

  support exclusive button group behaviour even when one of the buttons
  is not a QRadioButton.


src/qt.pro    2.16  paul  +6 -0
src/widgets/qgrid.cpp    1.1  paul  initial checkin
src/widgets/qgrid.h    1.1  paul  initial checkin
src/widgets/qhbox.cpp    1.1  paul  initial checkin
src/widgets/qhbox.h    1.1  paul  initial checkin
src/widgets/qvbox.cpp    1.1  paul  initial checkin
src/widgets/qvbox.h    1.1  paul  initial checkin

  New layout widgets


src/tools/qdstream.h    2.4  warwick  +2 -2

  QDataStream::eof() now returns TRUE if no device is set (as documented).


src/tools/qfile.cpp    2.14  warwick  +36 -19
src/tools/qiodev.cpp    2.8  warwick  +8 -5

  Test the file in QFile::open(FILE*) to see if it is seekable (not a
  char device, fifo, or socket), rather than assuming stdin/out/err are not.
  Set type to Sequential for such files, not default Direct.
  
  Don't use feof(fh) to mean at()==size().  QFile::atEnd() now works the
  same as QIODevice and QBuffer.
  
  setStatus(IO_ReadError) in appropriate places (wasn't ever set for files).
  Reading EOF is considered an error in the QIODevice model (see QBuffer).


src/kernel/qasyncimageio.cpp    1.26  warwick  +37 -30
src/kernel/qasyncimageio.h    1.13  warwick  +2 -2

  Work for even weirder GIFs.


src/tools/qfile.cpp    2.16  agulbra  +5 -4  (1998/02/25)

  -1 in case of error...


src/qt.pro    2.17  paul  +2 -0
src/widgets/qbuttonrow.cpp    1.1  paul  initial checkin
src/widgets/qbuttonrow.h    1.1  paul  initial checkin

  New layout widget


examples/aclock/GNUmakefile    2.1  hanord  initial checkin
examples/aclock/Makefile    2.2  hanord  +6 -53
examples/aclock/aclock.pro    1.4  hanord  +6 -6
examples/application/GNUmakefile    1.1  hanord  initial checkin
examples/application/application.pro    1.2  hanord  +6 -6
examples/biff/GNUmakefile    2.1  hanord  initial checkin
examples/biff/Makefile    2.2  hanord  +6 -54
examples/biff/biff.pro    1.4  hanord  +6 -6
examples/connect/GNUmakefile    2.1  hanord  initial checkin
examples/connect/Makefile    2.2  hanord  +6 -46
examples/connect/connect.pro    1.4  hanord  +5 -5
examples/cursor/GNUmakefile    2.1  hanord  initial checkin
examples/cursor/Makefile    2.2  hanord  +6 -46
examples/cursor/cursor.pro    1.4  hanord  +5 -5
examples/dclock/GNUmakefile    2.1  hanord  initial checkin
examples/dclock/Makefile    2.2  hanord  +6 -54
examples/dclock/dclock.pro    1.4  hanord  +6 -6
examples/desktop/GNUmakefile    2.1  hanord  initial checkin
examples/desktop/Makefile    2.2  hanord  +6 -46
examples/desktop/desktop.pro    1.4  hanord  +5 -5
examples/dirview/GNUmakefile    1.1  hanord  initial checkin
examples/drawdemo/GNUmakefile    2.1  hanord  initial checkin
examples/drawdemo/Makefile    2.2  hanord  +6 -52
examples/drawdemo/drawdemo.pro    1.4  hanord  +5 -5
examples/forever/GNUmakefile    2.1  hanord  initial checkin
examples/forever/Makefile    2.3  hanord  +6 -42
examples/forever/forever.pro    1.4  hanord  +5 -5
examples/hello/GNUmakefile    2.1  hanord  initial checkin
examples/hello/Makefile    2.8  hanord  +6 -61
examples/hello/hello.pro    1.5  hanord  +6 -5
examples/layout/GNUmakefile    1.1  hanord  initial checkin
examples/layout/Makefile    1.11  hanord  +7 -50
examples/layout/layout.pro    1.5  hanord  +5 -4
examples/life/GNUmakefile    2.1  hanord  initial checkin
examples/life/Makefile    2.2  hanord  +6 -57
examples/life/life.pro    2.3  hanord  +8 -8
examples/menu/GNUmakefile    2.1  hanord  initial checkin
examples/menu/Makefile    2.4  hanord  +6 -55
examples/menu/menu.pro    2.3  hanord  +5 -5
examples/movies/GNUmakefile    1.1  hanord  initial checkin
examples/movies/Makefile    1.11  hanord  +6 -50
examples/movies/movies.pro    1.4  hanord  +5 -5
examples/network/GNUmakefile    1.1  hanord  initial checkin
examples/network/Makefile    1.7  hanord  +6 -82
examples/picture/GNUmakefile    2.1  hanord  initial checkin
examples/picture/Makefile    2.2  hanord  +6 -49
examples/picture/picture.pro    1.2  hanord  +6 -3
examples/pref/GNUmakefile    1.1  hanord  initial checkin
examples/pref/Makefile    1.4  hanord  +6 -53
examples/pref/pref.pro    1.4  hanord  +6 -6
examples/progress/GNUmakefile    1.1  hanord  initial checkin
examples/progress/Makefile    1.9  hanord  +6 -47
examples/progress/progress.pro    1.3  hanord  +5 -5
examples/qmag/GNUmakefile    2.1  hanord  initial checkin
examples/qmag/Makefile    2.2  hanord  +6 -52
examples/qmag/qmag.pro    2.3  hanord  +5 -5
examples/qwerty/GNUmakefile    1.1  hanord  initial checkin
examples/qwerty/Makefile    1.6  hanord  +5 -66
examples/qwerty/qwerty.pro    1.4  hanord  +6 -6
examples/scrollview/GNUmakefile    1.1  hanord  initial checkin
examples/scrollview/Makefile    1.4  hanord  +6 -56
examples/scrollview/scrollview.pro    1.3  hanord  +5 -5
examples/sheet/GNUmakefile    2.1  hanord  initial checkin
examples/sheet/Makefile    2.3  hanord  +6 -59
examples/showimg/GNUmakefile    2.1  hanord  initial checkin
examples/showimg/Makefile    2.12  hanord  +6 -58
examples/showimg/showimg.pro    2.7  hanord  +6 -9
examples/table/GNUmakefile    1.1  hanord  initial checkin
examples/table/Makefile    1.5  hanord  +5 -67
examples/table/table.pro    1.4  hanord  +6 -6
examples/tetrix/GNUmakefile    2.1  hanord  initial checkin
examples/tetrix/Makefile    2.5  hanord  +6 -70
examples/tetrix/tetrix.pro    2.4  hanord  +14 -14
examples/tictac/GNUmakefile    2.1  hanord  initial checkin
examples/tictac/Makefile    2.2  hanord  +6 -54
examples/tictac/tictac.pro    2.3  hanord  +6 -6
examples/timestmp/GNUmakefile    2.1  hanord  initial checkin
examples/timestmp/Makefile    2.2  hanord  +6 -46
examples/tooltip/GNUmakefile    1.1  hanord  initial checkin
examples/tooltip/Makefile    1.3  hanord  +6 -53
examples/tooltip/tooltip.pro    1.3  hanord  +6 -6
examples/validator/GNUmakefile    1.1  hanord  initial checkin
examples/validator/Makefile    1.3  hanord  +6 -38
examples/widgets/GNUmakefile    2.1  hanord  initial checkin
examples/widgets/Makefile    2.4  hanord  +6 -67
examples/widgets/widgets.pro    2.3  hanord  +5 -9
examples/xform/GNUmakefile    2.1  hanord  initial checkin
examples/xform/Makefile    2.4  hanord  +6 -52
examples/xform/xform.pro    2.3  hanord  +6 -5
src/GNUmakefile    2.1  hanord  initial checkin
src/Makefile    2.22  hanord  +6 -156

  New makefile system


src/widgets/qframe.cpp    2.14  agulbra  +6 -6

  no reason to call drawContents() in [HV]Line mode


src/kernel/qfont.cpp    2.18  warwick  +3 -2
src/kernel/qfontdta.h    2.8  warwick  +2 -1
src/kernel/qfontmet.h    2.6  warwick  +9 -3
src/kernel/qpainter.cpp    2.20  warwick  +564 -2
src/kernel/qpainter.h    2.16  warwick  +2 -1
src/kernel/qptr_x11.cpp    2.34  warwick  +2 -546

  QPainter::drawText(...tf...) now takes into account the left and
  right bearings of the font.  The bounding rectangle of text may now
  be slightly larger (particularly italic text).  QFontMetrics has
  the additional functionality allowing this.


src/kernel/qaccel.cpp    2.8  agulbra  +70 -2  (1998/02/28)

  added common accelerator keys for later inclusion into docs


src/kernel/qfont.cpp    2.21  warwick  +110 -2  (1998/03/01)
src/kernel/qfontmet.h    2.8  warwick  +7 -1
src/kernel/qpainter.cpp    2.22  warwick  +43 -26
src/kernel/qpainter.h    2.17  warwick  +5 -1
src/widgets/qchkbox.cpp    2.18  warwick  +23 -29
src/widgets/qpushbt.cpp    2.35  warwick  +5 -5
src/widgets/qradiobt.cpp    2.24  warwick  +24 -29

  QFontMetrics::size() and QFontMetrics::boundingRect() with all the
  functionality of QPainter::boundingRect() - code now shared.
  
  Use QFontMetrics::size() in button size hints, thus allowing multi-line
  button labels.  Position checkbox/radiobutton top-left.


src/kernel/qpm_x11.cpp    2.30  eiriken  +78 -3  (1998/03/02)

  Fix convertToImage() for pixmaps with other than 8-bit-per-channel.


src/kernel/qpixmap.cpp    2.24  hanord  +7 -33
src/kernel/qpixmap.h    2.16  hanord  +21 -2
src/kernel/qpm_win.cpp    2.32  hanord  +110 -51
src/kernel/qpm_x11.cpp    2.31  hanord  +165 -84
src/kernel/qptd_win.cpp    2.7  hanord  +102 -29
src/kernel/qptd_x11.cpp    2.10  hanord  +41 -11

  Implemented masked bitBlt for Windows 95.
  Added QPixmap::setOptimization() which replaces the old optimize function.
  E.g. setOptimization(QPixmap::BestOptim) to get much faster masked bitBlts.
  Removed the dirty system, instead delete cached data whenever the pixmap
  is changed.


src/kernel/qprinter.h    2.3  eiriken  +6 -1
src/kernel/qprn_win.cpp    2.7  eiriken  +17 -7
src/kernel/qprn_x11.cpp    2.7  eiriken  +10 -5
src/kernel/qpsprn.cpp    2.9  eiriken  +8 -10

  Take display vs. font resolution into account for printer font metrics.


src/kernel/qpshdr.txt    2.3  agulbra  +91 -3
src/kernel/qpsprn.cpp    2.10  agulbra  +644 -88

  added iso-8859-1 support
  
  also added better font support.  try to print palatino, and the printer
  goes "hm, is palatino installed?  if not, perhaps garamond is installed?
  if not, is times installed?  if not, well, courier MUST work".
  
  finally, if I understand the postscript book correctly I think I made
  two-font postscript text output a little faster.  the code now attempts
  to use variables for fonts and call findfont/makefont just once per font
  change per page.
  
  this code is not perfect.  the hacky stuff that does font substitution
  needs tweaking, and at present the code believes that all the world is
  iso-8859-1.  will fix that.
  
  postscript is fun.


src/widgets/qmenudta.cpp    2.10  warwick  +4 -4

  Fix this->changeItem(this->pixmap(), "crashme")


src/kernel/qapp_win.cpp    2.74  agulbra  +7 -2  (1998/03/10)

  Set WState_Visible correctly when the window is (de)iconified.
  

src/kernel/qdrawutl.cpp    2.16  warwick  +5 -3  (1998/03/11)
src/kernel/qpmcache.cpp    2.3  warwick  +77 -5
src/kernel/qpmcache.h    2.3  warwick  +3 -1
src/kernel/qptr_x11.cpp    2.36  warwick  +5 -3
src/tools/qgcache.cpp    2.5  warwick  +10 -2

  Fix extremely-unlikely-to-be-triggered undeleted cached pixmaps.
  Provide safer QPixmapCache find() and insert().


src/widgets/qbutton.h    2.14  agulbra  +3 -2  (1998/03/12)

  add toggle()


src/tools/qregexp.cpp    2.7  agulbra  +23 -18

  implement [] in wildcard mode


src/kernel/qobject.cpp    2.44  agulbra  +29 -11
src/kernel/qobject.h    2.9  agulbra  +5 -1
src/widgets/qbuttonrow.cpp    1.3  agulbra  +8 -6
src/widgets/qframe.cpp    2.16  agulbra  +4 -4
src/widgets/qheader.cpp    2.30  agulbra  +6 -4
src/widgets/qlcdnum.cpp    2.9  agulbra  +7 -5
src/widgets/qmainwindow.cpp    2.9  agulbra  +4 -3
src/widgets/qscrbar.cpp    2.33  agulbra  +14 -14
src/widgets/qslider.cpp    2.48  agulbra  +4 -4
src/widgets/qtablevw.cpp    2.42  agulbra  +10 -8
src/widgets/qtoolbar.cpp    2.10  agulbra  +4 -4

  provide QObject::name( const char * defaultName ).
  
  use name( "unnamed" ) in all the debug() calls, to avoid segfaults
  where printf() won't handle null pointers.


src/tools/qstring.cpp    2.18  agulbra  +5 -9

  toDouble() of a null string now sets ok to FALSE


src/widgets/qcombo.cpp    2.73  agulbra  +54 -49
src/widgets/qcombo.h    2.25  agulbra  +3 -1

  tweaked size hint for toolbar use.  provide functions to change the
  line-edit without changint the combo's contents.


src/kernel/qapp_win.cpp    2.78  warwick  +13 -2

  Don't let Windows beep on WM_SYSCHAR events.
  Beep on unaccepted accelerations.


src/kernel/qpainter.cpp    2.29  hanord  +96 -17
src/kernel/qptr_x11.cpp    2.40  hanord  +2 -70

  Fixed QPainter::drawPixmap() bug (mono bitmaps with self-masks)
  Moved platform indep. code to qpainter.cpp
  Put back CtorBegin


src/widgets/qbttngrp.cpp    2.9  agulbra  +14 -2
src/widgets/qbttngrp.h    2.5  agulbra  +3 -1

  added setButton() - very useful when you want to force one member of
  an exclusive button group to on but not keep around pointers to
  umpteen radio buttons.


src/kernel/qprinter.cpp    2.5  agulbra  +31 -6
src/kernel/qprinter.h    2.5  agulbra  +6 -2

  added setPageOrder()


src/kernel/qobject.cpp    2.45  agulbra  +18 -2

  give better warnings in case of connect() mismatches.


src/dialogs/qprndlg.cpp    2.4  agulbra  +258 -112
src/dialogs/qprndlg.h    2.5  agulbra  +9 -2

  it's finished.  please have a look.  and please do debug.  I don't
  know about any bugs now, but I'm sure there are some.


src/widgets/qcombo.cpp    2.75  agulbra  +15 -6

  magic hack to make combos usable in dialogs.  (QDialog breaks the
  combo Enter key press.)


src/dialogs/qprndlg.cpp    2.3  agulbra  +543 -187
src/dialogs/qprndlg.h    2.4  agulbra  +24 -10
src/kernel/qprn_x11.cpp    2.8  agulbra  +4 -2

  new better-looking print dialog and a new static function to configure
  a QPrinter (replaces QPrinter::setup() - kernel/* should not use
  dialogs/*).
  
  noteworthy points:
  
   - the new static function appears to write over something it
     shouldn't.  I don't see why, but it does seem to cause crashes
     later on.  the old function works.  I'm committing so I can run
     purify on solaris.
   - the dialog lacks accelerators.
   - I haven't put in solaris /etc/lp/ support yet.  should be fairly
     easy, but I haven't done it.
   - the layout will benefit from Warwick's alternative space
     distribution
   - the awful message in qprndlg.h is gone gone gone.


src/dialogs/qprndlg.cpp    2.5  agulbra  +119 -23  (1998/03/15)

  /etc/lp support


src/widgets/qcombo.cpp    2.76  agulbra  +2 -3

  don't ignore key events, just don't accept them.


src/kernel/qapp.cpp    2.48  agulbra  +3 -2
src/kernel/qfont.cpp    2.27  agulbra  +11 -5

  look at $LANG and try to pick an application font that suits $LANG.
  the application font used is 12-point helvetica.  if the locale isn't
  in the list I built from XFree86's locale.alias, I assume 8859-1 is
  okay.
  
  copy character set from defFont in the relevant QFont constructor.
  
  this code assumes that helvetica includes the appropriate character
  set.


examples/qmag/qmag.cpp    2.13  warwick  +39 -2

  Crazy hard-disk chewing MultiSave option.  Great when you want to make
  animated GIFs for your web pages.


src/dialogs/qprndlg.cpp    2.8  warwick  +4 -4
src/kernel/qsize.cpp    2.6  warwick  +9 -3
src/kernel/qsize.h    2.6  warwick  +9 -3

  Add QSize::expandedTo(), and boundedTo().


src/kernel/qwidget.cpp    2.92  agulbra  +7 -6

  remove the widget's willingness to accept focus-in events very early
  in the destructor


src/tools/qgdict.cpp    2.11  warwick  +56 -11  (1998/03/17)
src/tools/qgdict.h    2.3  warwick  +3 -1

  Add QDict::resize(int).


src/widgets/qlined.cpp    2.64  agulbra  +46 -9
src/widgets/qlined.h    2.25  agulbra  +6 -2

  add setSelection() and setCursorPosition()


src/widgets/qcombo.cpp    2.77  agulbra  +86 -11
src/widgets/qcombo.h    2.26  agulbra  +4 -1

  setAutoCompletion() - works really nicely.


src/kernel/qiconset.cpp    2.1  agulbra  initial checkin
src/kernel/qiconset.h    2.1  agulbra  initial checkin

  QIconSet first checking.  QIconSet is neat: You give it one or more
  icons, and it completes the set so you get large and small disabled,
  active and normal icons.  QToolButton uses it, QMenuData will soon.


src/kernel/qpainter.cpp    2.31  agulbra  +18 -2
src/kernel/qpainter.h    2.22  agulbra  +2 -1

  added drawImage() by request of eng.  did NOT implement the QPrinter
  shortcut he asked for.


src/kernel/qapp.cpp    2.49  warwick  +10 -6  (1998/03/19)

  Ensure mouserelease goes to widget that got mousepress.
  Document -ncols better.


examples/qdir/GNUmakefile    1.1  warwick  initial checkin
examples/qdir/Makefile    1.1  warwick  initial checkin
examples/qdir/qdir.cpp    1.1  warwick  initial checkin

  Tests QFileDialog features.


extensions/nsplugin/src/qnp.cpp    1.18  warwick  +4 -1

  Work for multi-visual displays.


extensions/opengl/examples/box/.cvsignore    1.2  aavit  +0 -1
extensions/opengl/examples/box/glbox.cpp    1.4  aavit  +15 -6
extensions/opengl/examples/box/glbox.h    1.5  aavit  +2 -1
extensions/opengl/examples/gear/gear.cpp    1.5  aavit  +26 -35
extensions/opengl/src/qgl.cpp    1.18  aavit  +127 -41
extensions/opengl/src/qgl.h    1.8  aavit  +80 -77

  New features in OpenGL extension:
  1) virtual initalizeGL() method in QGLWidget; facilitates easier GL initialization.
  2) Added support for using shared OpenGL display lists
  3) Added sharedbox example showing this feature.


